#ifndef MP3X_H_LOADED
#define MP3X_H_LOADED 1

#include <inttypes.h>

typedef const uint8_t cbyte;

struct mp3_header_info {
    struct id3v2_header *metadata; /* array */
    int nmetadata;                 /* number of metadata items */
    int metadata_size;             /* number of items in metadata[], of which nmetadata are used */
    char* filename;
    uint8_t major_version;
    uint8_t minor_version;
    uint8_t flags;
    size_t padding;       /* number of available bytes of padding */
    cbyte* base;          /* position of buffer holding header+data */
    cbyte* audio;
    cbyte* audio_end;
};
typedef struct mp3_header_info MP3Info;

const char* program_name();

#define VERBOSE_QUIET 0
#define VERBOSE_CHATTY 1
#define VERBOSE_DETAILS 2
#define VERBOSE_DEBUG 3

#define INCLUDE_COVERAGE 1
// see mp3x.c for support here
// Important branches should have a COVERAGE(id); in them.  
// 'make check-coverage' checks that each of these branches is indeed
// covered in a call to 'make check'
#if INCLUDE_COVERAGE
  extern FILE* coverage;
  #define COVERAGE(id) if (coverage != NULL) { fputs("COVERED:" #id "\n", coverage); }
#else
  #define COVERAGE(id)
#endif

#endif /* MP3X_H_LOADED */
